// databasedemo.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "adatabase.h"

#define KEYLEN		3
#define NAMELEN		30
#define	ADDLEN		30
#define CITYLEN		15
#define STATELEN	2
#define ZIPLEN		5
#define DATASIZE	NAMELEN + ADDLEN + CITYLEN + STATELEN + ZIPLEN
#define INITRECS	100

	ADataBase		testdb;
	char			path[MAX_PATH];
	char			data[DATASIZE + KEYLEN + 2];
	char			msg[1024];
	char			name[NAMELEN+2];
	char			add[ADDLEN+2];
	char			city[CITYLEN+2];
	char			state[STATELEN+2];
	char			zip[ZIPLEN+2];

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.

	// figure out wher to put it
	lstrcpy(path, getenv("TEMP"));
	if (0 == strlen(path))
	{
		strcpy(path, "c:");
	}
	// name it
	strcat(path, "\\database.db");
	// set up the names in the class
	testdb.SetName(path);
	// have we already done this?
	if (!testdb.OpenTest())
	{
		// creaate the database
		testdb.Create(KEYLEN,
						DATASIZE,
						INITRECS,
						AUTOGROW + AUTOSORT + AUTOREORG);
	}
	if (!testdb.Open())
	{
		// highly unlikely
		exit(EEXIT);
	}
	// optional
	testdb.SetParams(0, 50, 50, 5);
	// describe the fields to this instance of the database
	testdb.SetFields(KEYLEN, NAMELEN, ADDLEN, CITYLEN, STATELEN, ZIPLEN, NULL);
	// create the data for a record
	testdb.PutField(1, "Rick Marsh.", data);
	testdb.PutField(2, "832 Wecoma Lp.", data);
	testdb.PutField(3, "Florence", data);
	testdb.PutField(4, "OR", data);
	testdb.PutField(5, "97439", data);
	// add it. Notice the key does not begin with a space
	if (!testdb.Set("005", data))
	{
		MessageBox(NULL, "Set error.", "Error", MB_ICONERROR);
		exit(EEXIT);
	}
	// sort the index
	testdb.Close();
	if (!testdb.Sort())
	{
		// somebody has it open.
		exit(EEXIT);
	}
	if (!testdb.Open())
	{
		// serious problem
		exit(EEXIT);
	}
	testdb.DisplayStatus("Record added and sorted.\r\nWe will now get the data.");
	// retrieve the record
	if (testdb.Get("005"))
	{
		strcpy(name, testdb.GetField(1));
		strcpy(add, testdb.GetField(2));
		strcpy(city, testdb.GetField(3));
		strcpy(state, testdb.GetField(4));
		strcpy(zip, testdb.GetField(5));
		sprintf(msg,
			"%s\r\n%s\r\n%s, %s %s",
			name,
			add,
			city,
			state,
			zip
			);
		MessageBox(NULL, msg, "Info", MB_ICONINFORMATION);
	}
	else
	{
		MessageBox(NULL, "Could not find the record.", "Error", MB_ICONERROR);
		// ordinarily you would do something less drastic.
		exit(EEXIT);
	}
	if (!testdb.DeleteRec())
	{
		MessageBox(NULL, "Could not delete the record.", "Error", MB_ICONERROR);
		exit(EEXIT);
	}
	// this is important
	testdb.Close();
	// normal exit of program
	return 0;
}



